# Generated by sila2.code_generator; sila2.__version__: 0.8.0
from __future__ import annotations

import math
import time
from concurrent.futures import Executor
from threading import Event
from typing import Any, Dict

from sila2.server import MetadataDict, SilaServer

from ....device_drivers import BalanceInterface
from ..generated.balanceservice import BalanceServiceBase, Tare_Responses


class BalanceServiceImpl(BalanceServiceBase):
    __balance: BalanceInterface
    __stop_event: Event

    def __init__(self, server: SilaServer, balance: BalanceInterface, executor: Executor):
        super().__init__(server)
        self.__balance = balance
        self.__stop_event = Event()

        def update_value(stop_event: Event):
            new_value = value = self.__balance.value
            while not stop_event.is_set():
                new_value = self.__balance.value
                if not math.isclose(new_value, value):
                    value = new_value
                    self.update_Value(value)
                time.sleep(0.1)

        # initial value
        self.update_Value(self.__balance.value)

        executor.submit(update_value, self.__stop_event)

    def Tare(self, *, metadata: MetadataDict) -> Tare_Responses:
        self.__balance.tare()

    def stop(self) -> None:
        super().stop()
        self.__stop_event.set()
