# Generated by sila2.code_generator; sila2.__version__: 0.8.0
from __future__ import annotations

from abc import ABC, abstractmethod
from queue import Queue
from typing import TYPE_CHECKING, Optional

from sila2.server import FeatureImplementationBase, MetadataDict

from .balanceservice_types import Tare_Responses

if TYPE_CHECKING:
    from sila2.server import SilaServer


class BalanceServiceBase(FeatureImplementationBase, ABC):

    _Value_producer_queue: Queue[float]

    def __init__(self, parent_server: SilaServer):
        """
        Provides an interface to a balance to read its current value and tare the balance if necessary
        """
        super().__init__(parent_server=parent_server)

        self._Value_producer_queue = Queue()

    def update_Value(self, Value: float, queue: Optional[Queue[float]] = None):
        """
        The current value

        This method updates the observable property 'Value'.
        """
        if queue is None:
            queue = self._Value_producer_queue
        queue.put(Value)

    def Value_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[float]]:
        """
        The current value

        This method is called when a client subscribes to the observable property 'Value'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass

    @abstractmethod
    def Tare(self, *, metadata: MetadataDict) -> Tare_Responses:
        """
        Tare the balance


        :param metadata: The SiLA Client Metadata attached to the call

        """
        pass
