# Generated by sila2.code_generator; sila2.__version__: 0.8.0
from __future__ import annotations

from abc import ABC
from queue import Queue
from typing import TYPE_CHECKING, Optional

from sila2.server import FeatureImplementationBase, MetadataDict

if TYPE_CHECKING:
    from sila2.server import SilaServer


class SystemStatusProviderBase(FeatureImplementationBase, ABC):

    _SystemState_producer_queue: Queue[str]

    def __init__(self, parent_server: SilaServer):
        """
        Provides information about the overall system, e.g. if the system is operational or not
        """
        super().__init__(parent_server=parent_server)

        self._SystemState_producer_queue = Queue()

    def update_SystemState(self, SystemState: str, queue: Optional[Queue[str]] = None):
        """
        The state of the system, e.g. if the system is operational or not. 'Operational' means that the system can process Commands and that all Property values are read from the device. 'Stopped' means that the system is unable to process Commands (i.e. all Execution will result in errors) and that Property values are not read from the device and might have outdated values.

        This method updates the observable property 'SystemState'.
        """
        if queue is None:
            queue = self._SystemState_producer_queue
        queue.put(SystemState)

    def SystemState_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[str]]:
        """
        The state of the system, e.g. if the system is operational or not. 'Operational' means that the system can process Commands and that all Property values are read from the device. 'Stopped' means that the system is unable to process Commands (i.e. all Execution will result in errors) and that Property values are not read from the device and might have outdated values.

        This method is called when a client subscribes to the observable property 'SystemState'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass
