# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/), and this project adheres
to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

<!--
Types of changes

    `Added` for new features.
    `Changed` for changes in existing functionality.
    `Deprecated` for soon-to-be removed features.
    `Removed` for now removed features.
    `Fixed` for any bug fixes.
    `Security` in case of vulnerabilities.
-->

## Unreleased

## v1.8.0

Sync with sila_cetoni v1.8.0 release

### Changed

- Bump required sila2 version to v0.10.1
- Rename Huber temperature control modes for more clarity
- Increase required Python version to 3.8 because in 3.7 the implementation of `ThreadPoolExecutor` in the standard library does not reuse idle threads leading to an ever increasing number of threads which eventually causes blocking of the server(s) on Raspberry Pis

## v1.7.1

Sync with sila_cetoni v1.7.1 release

### Fixed

- Typo in pyproject.toml

## v1.7.0

Sync with sila_cetoni v1.7.0

### Added

- MemmertOvenControlService feature to control Memmert ovens
- Real and simulated device driver implementation for the MemmertOvenControlService

### Changed

- The TemperatureControlService feature has been renamed to HuberChillerControlService as it is designed for Huber devices
- Bump required sila2 version to v0.10.0

### Fixed

- When `SerialTemperatureControllerInterface.start` failed no `SerialTemperatureControllerNotFoundException` was raised
- Sometimes the actual temperature values of Huber Chillers did not change for multiple seconds because the driver implementation waited too long for the response of another command

## v1.6.1

### Fixed

- Add missing default argument in `__init__` of the not found exception

## v1.6.0

Sync with sila_cetoni v1.6.0

### Changed

- Improve error message when a device cannot be connected to

## v1.5.1

### Added

- TemperatureControlService/Command/CahageSetPointValue/Parameter/SetPointValue causes a Validation Error if it is not in the SetPointRangeLimit

### Fixed

- Potential crash due to uncaught `SerialException`

## v1.5.0

Sync with sila_cetoni v1.5.0

## v1.4.0

Sync with sila_cetoni v1.4.0

## v1.3.0

Sync with sila_cetoni v1.3.0

### Fixed

- Properly call `super().stop()` in the feature implementation classes

## v1.2.0

Sync with sila_cetoni v1.2.0

### Added

- Simulated device driver implementation for Huber Chillers

## v1.1.0

Sync with sila_cetoni v1.1.0

## v1.0.0

This is the heating/cooling plugin which adds support for heating/cooling devices via SiLA 2

### Added

- TemperatureControllerService feature and implementation
- Device driver interface for temperature controller devices
- Device driver implementation for Huber Chiller
