# Generated by sila2.code_generator; sila2.__version__: 0.9.2
from __future__ import annotations

from typing import Set

from sila2.client import SilaClient
from sila2.framework import FullyQualifiedFeatureIdentifier

from .huberchillercontrolservice import HuberChillerControlServiceClient
from .memmertovencontrolservice import (
    MemmertOvenControlServiceClient,
    MemmertOvenControlServiceFeature,
    PermissionDenied,
    ValueOutOfRange,
)


class Client(SilaClient):

    HuberChillerControlService: HuberChillerControlServiceClient

    MemmertOvenControlService: MemmertOvenControlServiceClient

    _expected_features: Set[FullyQualifiedFeatureIdentifier] = {
        FullyQualifiedFeatureIdentifier("org.silastandard/core/SiLAService/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/heatingcooling/HuberChillerControlService/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/heatingcooling/MemmertOvenControlService/v1"),
    }

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self._register_defined_execution_error_class(
            MemmertOvenControlServiceFeature.defined_execution_errors["PermissionDenied"], PermissionDenied
        )

        self._register_defined_execution_error_class(
            MemmertOvenControlServiceFeature.defined_execution_errors["ValueOutOfRange"], ValueOutOfRange
        )
