# Generated by sila2.code_generator; sila2.__version__: 0.9.2
# -----
# This class does not do anything useful at runtime. Its only purpose is to provide type annotations.
# Since sphinx does not support .pyi files (yet?), so this is a .py file.
# -----

from __future__ import annotations

from typing import TYPE_CHECKING

if TYPE_CHECKING:

    from typing import Any, Iterable, List, Optional

    from memmertovencontrolservice_types import (
        ChangeSetPoint_Responses,
        SetFanRotationSpeed_Responses,
        SetFlapPosition_Responses,
        SetMaximumAlarmTemperature_Responses,
        SetMinimumAlarmTemperature_Responses,
    )
    from sila2.client import ClientMetadataInstance, ClientObservableProperty, ClientUnobservableProperty

    from .memmertovencontrolservice_types import Percent, Temperature


class MemmertOvenControlServiceClient:
    """
    Allows to control Memmert Oven devices
    """

    SetPointRange: ClientUnobservableProperty[Range]
    """
    The allowed range of temperatures for the Set Point Value
    """

    AlarmTemperatureRange: ClientUnobservableProperty[Range]
    """
    The allowed range of temperatures for the Minimum and Maximum Alarm Temperature
    """

    SetPointValue: ClientObservableProperty[Temperature]
    """
    The current set point value
    """

    ActualTemperature: ClientObservableProperty[Temperature]
    """
    The actual temperature of the device
    """

    AlarmTemperature: ClientObservableProperty[Range]
    """
    The minimum and maximum alarm temperature values
    """

    FanRotationSpeed: ClientObservableProperty[Percent]
    """
    The rotation speed of the fan in percent
    """

    FlapPosition: ClientObservableProperty[Percent]
    """
    The position of the flaps in percent (0 = fully closed, 100 = fully opened)
    """

    MinimumTemperatureUnderrun: ClientObservableProperty[bool]
    """
    The current temperature is lower than the configured minimum alarm temperature
    """

    MaximumTemperatureExceeded: ClientObservableProperty[bool]
    """
    The current temperature is higher than the configured maximum alarm temperature
    """

    EventLog: ClientObservableProperty[List[Any]]
    """
    A list of events that were logged by the device
    """

    def ChangeSetPoint(
        self, SetPointValue: Temperature, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> ChangeSetPoint_Responses:
        """
        Change the set point value. This will start the temperature control if necessary.
        """
        ...

    def SetMinimumAlarmTemperature(
        self, MinimumAlarmTemperature: Temperature, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetMinimumAlarmTemperature_Responses:
        """
        Set the minimum alarm temperature, i.e. the temperature that will cause an alarm if the actual temperature gets below it.
        """
        ...

    def SetMaximumAlarmTemperature(
        self, MaximumAlarmTemperature: Temperature, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetMaximumAlarmTemperature_Responses:
        """
        Set the maximum alarm temperature, i.e. the temperature that will cause an alarm if the actual temperature gets above it.
        """
        ...

    def SetFanRotationSpeed(
        self, Speed: Percent, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetFanRotationSpeed_Responses:
        """
        Set the fan rotation speed
        """
        ...

    def SetFlapPosition(
        self, Position: Percent, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetFlapPosition_Responses:
        """
        Set the flap position
        """
        ...
