# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/), and this project adheres
to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

<!--
Types of changes

    `Added` for new features.
    `Changed` for changes in existing functionality.
    `Deprecated` for soon-to-be removed features.
    `Removed` for now removed features.
    `Fixed` for any bug fixes.
    `Security` in case of vulnerabilities.
-->

## Unreleased

## v1.8.0

Sync with sila_cetoni v1.8.0 release

### Changed

- Bump required sila2 version to v0.10.1
- Increase required Python version to 3.8 because in 3.7 the implementation of `ThreadPoolExecutor` in the standard library does not reuse idle threads leading to an ever increasing number of threads which eventually causes blocking of the server(s) on Raspberry Pis

### Fixed

- Unit label of the Conductivity data type

## v1.7.1

Sync with sila_cetoni v1.7.1 release

### Fixed

- Typo in pyproject.toml

## v1.7.0

Sync with sila_cetoni v1.7.0

### Changed

- Bump required sila2 version to v0.10.0

## v1.6.1

### Fixed

- Add missing default argument in `__init__` of the not found exception

## v1.6.0

Sync with sila_cetoni v1.6.0

### Changed

- Improve error message when a device cannot be connected to

## v1.5.2

### Fixed

- Fix possible `ConnectionError` in the simulated Sartorius Arium driver due to the flask server not being ready yet

### Changed

- Turn down werkzeug's logger's level since it generates too much output

## v1.5.1

### Fixed

- Fix that the flask server spawned too many threads which was causing SiLA client applications to have to wait forever for Commands/Property reads to finish

## v1.5.0

Sync with sila_cetoni v1.5.0

### Added

- Error handling in case dispensing could not be started

### Changed

- Sartorius Arium alerts include the friendly name of the REST endpoint to be more explanatory

### Fixed

- Sartorius Arium reminders/alerts weren't using the friendly names
- Improve descriptions in the FDL

## v1.4.1

### Fixed

- Add missing dependencies in pyproject.toml

## v1.4.0

Sync with sila_cetoni v1.4.0

## v1.3.1

### Changed

- The list of reminders and alerts is now sorted by date/time for Sartorius Arium devices

## v1.3.0

Sync with sila_cetoni v1.3.0

### Fixed

- Properly call `super().stop()` in the feature implementation classes
- Stopping `SartoriusArium` device driver implementation is faster now

## v1.2.0

Sync with sila_cetoni v1.2.0

## v1.0.0

This is the purification plugin which adds support for purification (e.g. water purification) devices via SiLA 2

### Added

- WaterPurificationService feature and implementation
- Device driver interface for purification devices
- Device driver implementation for Sartorius Arium devices (real + simulated)
- Simulated Sartorius Arium REST server
