# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/), and this project adheres
to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

<!--
Types of changes

    `Added` for new features.
    `Changed` for changes in existing functionality.
    `Deprecated` for soon-to-be removed features.
    `Removed` for now removed features.
    `Fixed` for any bug fixes.
    `Security` in case of vulnerabilities.
-->

## Unreleased

## v1.8.0

Sync with sila_cetoni v1.8.0 release

### Changed

- Bump required sila2 version to v0.10.1
- The RPM data type's unit constraint now uses SI unit *Second* as base unit and not *Dimensionless*
- Increase required Python version to 3.8 because in 3.7 the implementation of `ThreadPoolExecutor` in the standard library does not reuse idle threads leading to an ever increasing number of threads which eventually causes blocking of the server(s) on Raspberry Pis

## v1.7.1

Sync with sila_cetoni v1.7.1 release

### Fixed

- Typo in pyproject.toml

## v1.7.0

Sync with sila_cetoni v1.7.0

### Changed

- Bump required sila2 version to v0.10.0

### Fixed

- Settings invalid values did not always catch the error message we get from the device and thus the invalid value was able to be set

### Fixed

- When `SerialStirringDeviceInterface.start` failed no `SerialStirringDeviceNotFoundException` was raised

## v1.6.1

### Fixed

- Add missing default argument in `__init__` of the not found exception

## v1.6.0

Sync with sila_cetoni v1.6.0

### Changed

- Improve error message when a device cannot be connected to

## v1.5.1

### Changed

- Improve validation before sending commands to the MIXcontrol
- Improve error messages with more info to give the user a hint how valid values have to look like

### Fixed

- Catch possible errors when trying to set invalid values that were read from the config file

## v1.5.0

Sync with sila_cetoni v1.5.0

## v1.4.1

### Fixed

- Add missing dependencies in pyproject.toml

## v1.4.0

Sync with sila_cetoni v1.4.0

## v1.3.0

Sync with sila_cetoni v1.3.0

### Changed

- StirringService/DataType/RPM now has a MinimalInclusive constraint of 0

### Fixed

- Properly call `super().stop()` in the feature implementation classes

## v1.2.0

Sync with sila_cetoni v1.2.0

## v1.0.0

This is the sila_cetoni_stirring plugin which adds support for stirring devices via SiLA 2

### Added

- StirringService feature and feature implementation
- Device driver interface for stirring devices
- Device driver implementation for 2mag MIXdrive devices (real + simulated)
